Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.xml.transform
Class TransformerFactory

    java.lang.Object
      |
      +--javax.xml.transform.TransformerFactory

Direct Known Subclasses:
  SAXTransformerFactory

public abstract class TransformerFactory
extends java.lang.Object

A TransformerFactory instance can be used to create `Transformer` and `Templates` objects.

The system property that determines which Factory implementation to create is named `"javax.xml.transform.TransformerFactory"`. This property names a concrete subclass of the `TransformerFactory` abstract class. If the property is not defined, a platform default is be used.

Author:
  Jeff Suttor

Constructor Summary
`protected` | `TransformerFactory()` Default constructor is protected on purpose.

Method Summary
`abstract Source` | `getAssociatedStylesheet(Source source, java.lang.String media, java.lang.String title, java.lang.String charset)` Get the stylesheet specification(s) associated with the XML `Source` document via the xml-stylesheet processing instruction that match the given criteria.
`abstract java.lang.Object` | `getAttribute(java.lang.String name)` Allows the user to retrieve specific attributes on the underlying implementation.
`abstract ErrorListener` | `getErrorListener()` Get the error event handler for the TransformerFactory.
`abstract boolean` | `getFeature(java.lang.String name)` Look up the value of a feature.
`abstract URIResolver` | `getURIResolver()` Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
`static TransformerFactory` | `newInstance()` Obtain a new instance of a `TransformerFactory`.
`static TransformerFactory` | `newInstance(java.lang.String factoryClassName, java.lang.ClassLoader classLoader)`
`abstract Templates` | `newTemplates(Source source)` Process the Source into a Templates object, which is a a compiled representation of the source.
`abstract Transformer` | `newTransformer()` Create a new `Transformer` that performs a copy of the `Source` to the `Result`.
`abstract Transformer` | `newTransformer(Source source)` Process the `Source` into a `Transformer` `Object`.
`abstract void` | `setAttribute(java.lang.String name, java.lang.Object value)` Allows the user to set specific attributes on the underlying implementation.
`abstract void` | `setErrorListener(ErrorListener listener)` Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.
`abstract void` | `setFeature(java.lang.String name, boolean value)` Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.
`abstract void` | `setURIResolver(URIResolver resolver)` Set an object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TransformerFactory

    protected TransformerFactory()

  Default constructor is protected on purpose.

Method Detail

### newInstance

    public static TransformerFactory newInstance()
                                          throws TransformerFactoryConfigurationError

  Obtain a new instance of a `TransformerFactory`. This static method creates a new factory instance This method uses the following ordered lookup procedure to determine the `TransformerFactory` implementation class to load:
  - Use the `javax.xml.transform.TransformerFactory` system property.
  - Use the properties file "lib/jaxp.properties" in the JRE directory. This configuration file is in standard `java.util.Properties` format and contains the fully qualified name of the implementation class with the key being the system property defined above. The jaxp.properties file is read only once by the JAXP implementation and it's values are then cached for future use. If the file does not exist when the first attempt is made to read from it, no further attempts are made to check for its existence. It is not possible to change the value of any property in jaxp.properties after it has been read for the first time.
  - Use the Services API (as detailed in the JAR specification), if available, to determine the classname. The Services API will look for a classname in the file `META-INF/services/javax.xml.transform.TransformerFactory` in jars available to the runtime.
  - Platform default `TransformerFactory` instance.
  Once an application has obtained a reference to a `TransformerFactory` it can use the factory to configure and obtain parser instances.
  Returns:
    new TransformerFactory instance, never null.
  Throws:
    `TransformerFactoryConfigurationError` - Thrown if the implementation is not available or cannot be instantiated.

### newInstance

    public static TransformerFactory newInstance(java.lang.String factoryClassName,
                                                 java.lang.ClassLoader classLoader)
                                          throws TransformerFactoryConfigurationError

  Returns:
    new TransformerFactory instance, never null.
  Throws:
    `TransformerFactoryConfigurationError` - Thrown if the implementation is not available or cannot be instantiated.

### newTransformer

    public abstract Transformer newTransformer(Source source)
                                        throws TransformerConfigurationException

  Process the `Source` into a `Transformer` `Object`. The `Source` is an XSLT document that conforms to XSL Transformations (XSLT) Version 1.0. Care must be taken not to use this `Transformer` in multiple `Thread`s running concurrently. Different `TransformerFactories` can be used concurrently by different `Thread`s.

  Parameters:
    `source` - `Source` of XSLT document used to create `Transformer`. Examples of XML `Source`s include `StreamSource`, `SAXSource`, `DOMSource` and `StAXSource`.
  Returns:
    A `Transformer` object that may be used to perform a transformation in a single `Thread`, never `null`.
  Throws:
    `TransformerConfigurationException` - Thrown if there are errors when parsing the `Source` or it is not possible to create a `Transformer` instance.
  See Also:
    XSL Transformations (XSLT) Version 1.0

### newTransformer

    public abstract Transformer newTransformer()
                                        throws TransformerConfigurationException

  Create a new `Transformer` that performs a copy of the `Source` to the `Result`. i.e. the "identity transform".

  Returns:
    A Transformer object that may be used to perform a transformation in a single thread, never null.
  Throws:
    `TransformerConfigurationException` - Thrown if it is not possible to create a `Transformer` instance.

### newTemplates

    public abstract Templates newTemplates(Source source)
                                    throws TransformerConfigurationException

  Process the Source into a Templates object, which is a a compiled representation of the source. This Templates object may then be used concurrently across multiple threads. Creating a Templates object allows the TransformerFactory to do detailed performance optimization of transformation instructions, without penalizing runtime transformation.
  Parameters:
    `source` - An object that holds a URL, input stream, etc.
  Returns:
    A Templates object capable of being used for transformation purposes, never null.
  Throws:
    `TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

### getAssociatedStylesheet

    public abstract Source getAssociatedStylesheet(Source source,
                                                   java.lang.String media,
                                                   java.lang.String title,
                                                   java.lang.String charset)
                                            throws TransformerConfigurationException

  Get the stylesheet specification(s) associated with the XML `Source` document via the xml-stylesheet processing instruction that match the given criteria. Note that it is possible to return several stylesheets, in which case they are applied as if they were a list of imports or cascades in a single stylesheet.

  Parameters:
    `source` - The XML source document.
    `media` - The media attribute to be matched. May be null, in which case the preferred templates will be used (i.e. alternate = no).
    `title` - The value of the title attribute to match. May be null.
    `charset` - The value of the charset attribute to match. May be null.
  Returns:
    A `Source` `Object` suitable for passing to the `TransformerFactory`.
  Throws:
    `TransformerConfigurationException` - An `Exception` is thrown if an error occurs during parsing of the `source`.
  See Also:
    Associating Style Sheets with XML documents Version 1.0

### setURIResolver

    public abstract void setURIResolver(URIResolver resolver)

  Set an object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
  Parameters:
    `resolver` - An object that implements the URIResolver interface, or null.

### getURIResolver

    public abstract URIResolver getURIResolver()

  Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
  Returns:
    The URIResolver that was set with setURIResolver.

### setFeature

    public abstract void setFeature(java.lang.String name,
                                    boolean value)
                             throws TransformerConfigurationException

  Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.

  Feature names are fully qualified `java.net.URI`s. Implementations may define their own features. An `TransformerConfigurationException` is thrown if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support the feature. It is possible for an `TransformerFactory` to expose a feature value but be unable to change its state.

  All implementations are required to support the `XMLConstants.FEATURE_SECURE_PROCESSING` feature. When the feature is:

  - `true`: the implementation will limit XML processing to conform to implementation limits and behave in a secure fashion as defined by the implementation. Examples include resolving user defined style sheets and functions. If XML processing is limited for security reasons, it will be reported via a call to the registered `ErrorListener.fatalError(TransformerException exception)`. See `setErrorListener(ErrorListener listener)`.
  - `false`: the implementation will processing XML according to the XML specifications without regard to possible implementation limits.
  Parameters:
    `name` - Feature name.
    `value` - Is feature state `true` or `false`.
  Throws:
    `TransformerConfigurationException` - if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support this feature.
    `java.lang.NullPointerException` - If the `name` parameter is null.

### getFeature

    public abstract boolean getFeature(java.lang.String name)

  Look up the value of a feature.

  Feature names are fully qualified `java.net.URI`s. Implementations may define their own features. `false` is returned if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support the feature. It is possible for an `TransformerFactory` to expose a feature value but be unable to change its state.

  Parameters:
    `name` - Feature name.
  Returns:
    The current state of the feature, `true` or `false`.
  Throws:
    `java.lang.NullPointerException` - If the `name` parameter is null.

### setAttribute

    public abstract void setAttribute(java.lang.String name,
                                      java.lang.Object value)

  Allows the user to set specific attributes on the underlying implementation. An attribute in this context is defined to be an option that the implementation provides. An `IllegalArgumentException` is thrown if the underlying implementation doesn't recognize the attribute.
  Parameters:
    `name` - The name of the attribute.
    `value` - The value of the attribute.

### getAttribute

    public abstract java.lang.Object getAttribute(java.lang.String name)

  Allows the user to retrieve specific attributes on the underlying implementation. An `IllegalArgumentException` is thrown if the underlying implementation doesn't recognize the attribute.
  Parameters:
    `name` - The name of the attribute.
  Returns:
    value The value of the attribute.

### setErrorListener

    public abstract void setErrorListener(ErrorListener listener)

  Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself. An `IllegalArgumentException` is thrown if the `ErrorListener` listener is `null`.
  Parameters:
    `listener` - The new error listener.

### getErrorListener

    public abstract ErrorListener getErrorListener()

  Get the error event handler for the TransformerFactory.
  Returns:
    The current error handler, which should never be null.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD